// C Source File
// Created 12/5/2003; 12:44:05 PM

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "eric.h"

	char version[]="2.4.2";
//Define global variables/arrays
	int drawcrd[26],drawsut[26];											//Define the draw stack (card/suit)
	int maincrd[20][7],mainsut[20][7];								//Define the playing area array (card/suit)
	int mainace[]={0,0,0,0};													//Define the ace stacks (for use during gameplay)
	int clb[13],dmnd[13],spd[13],hrt[13];							//Define the deck as 4 suits (clb=1, dmnd=2, spd=3, hrt=4)
	int row,col,t,c,draw;
	int selectd[]={0,0,0,0};
//Define functions (all are global)
	int sumit(int lst[13]);
	void drwcrd(int c,int s,int q,int w);
	void outln(int x);
	void drwclb(int r,int c);
	void drwdmnd(int r,int c);
	void drwspd(int r,int c);
	void drwhrt(int r,int c);
	void loccard(int col);
	void drawnxt(int x);

void _main(void)
{
/*The following code deals the game*/
	int lstpick,y,r,x,z,select,kng,key,e,b,d,time,card,min,reset=0,cont=0;
	int space[]={-1,-1,-1,-1};
	int options[]={1,1};
	char LCD_BUFFER[LCD_SIZE];

reset:
	ClrScr();
	randomize();
	select=0;
	lstpick=0;
	time=1;
	r=0;
	draw=0;
	drawcrd[0]=0;
	drawsut[0]=0;
	drawcrd[25]=-1;
	drawsut[25]=-1;
	for(x=0;x<4;x++)																	//Zero out the ace stacks and selection array
	{
		selectd[x]=0;
		mainace[x]=0;
	}
	for(x=0;x<20;x++)																	//Zero out the playing array (neccessary)
	{
		for(y=0;y<7;y++)
		{
			maincrd[x][y]=0;
			mainsut[x][y]=0;
		}
	}
	for(x=0;x<25;x++)																	//Zero out the draw stack (neccessary?)
	{
		drawcrd[x]=0;
		drawsut[x]=0;
	}
	for(x=0;x<13;x++)																	//Give each suit it's cards (1-13)
	{
		clb[x]=x+1;
		dmnd[x]=x+1;
		spd[x]=x+1;
		hrt[x]=x+1;
	}
	for(col=0;col<7;col++)														//Deal the cards to the playing array (column)
	{
		for(row=0;row<col+1;row++)											//Deal the cards to the playing array (row)
		{
			do
			{
				lstpick=random(4)+1;
			}	while(lstpick>4 && lstpick<1);
			goto logic;
top1:
			maincrd[row][col]=card;
			if(row!=col)
				lstpick=-lstpick;
			mainsut[row][col]=lstpick;
		}
	}
	time=2;
	for(y=1;;y++)																	//Deal the remaining cards to the draw stack
	{
		do
		{
			lstpick=random(4)+1;
		}	while(lstpick>4 && lstpick<1);
		goto logic;
top2:
		drawcrd[y]=card;
		drawsut[y]=lstpick;
	}
logic:
	card=0;
	if(sumit(clb)==0 && sumit(dmnd)==0 && sumit(spd)==0 && sumit(hrt)==0)
		goto done;
	if(lstpick==1 && sumit(clb)==0)
		lstpick++;
	if(lstpick==2 && sumit(dmnd)==0)
		lstpick++;
	if(lstpick==3 && sumit(spd)==0)
		lstpick++;
	if(lstpick==4 && sumit(hrt)==0)
	{
		lstpick=1;
		goto logic;
	}
	if(lstpick==1)
	{
		while(card==0)
		{
			r=random(13);
			card=clb[r];
		}
		clb[r]=0;
	}
	if(lstpick==2)
	{
		while(card==0)
		{
			r=random(13);
			card=dmnd[r];
		}
		dmnd[r]=0;
	}
	if(lstpick==3)
	{
		while(card==0)
		{
			r=random(13);
			card=spd[r];
		}
		spd[r]=0;
	}
	if(lstpick==4)
	{
		while(card==0)
		{
			r=random(13);
			card=hrt[r];
		}
		hrt[r]=0;
	}
	if(time==2)
		goto top2;
	goto top1;
done:
	if(reset!=1)
	{
		ClrScr();
		printf_xy(30,1,"Solitare 89 V %s",version);
		printf_xy(30,11,"Copyright 2002-2004");
		printf_xy(9,23,"Programmed by Techie1369");
		printf_xy(10,50,"Press any key to begin");
		printf_xy(10,60,"Press [APPS] for help");
		printf_xy(10,70,"Press [MODE] for options");
		key=ngetchx();
		if(key==265)
		{
			ClrScr();
			FontSetSys(F_4x6);
			printf_xy(0,0,"This guide will tell you what the keys do");
			printf_xy(0,10,"Use the arrow keys to move the cursor");
			printf_xy(10,17,"You can also move up or down a stack");
			printf_xy(10,24,"and to ace/draw stacks");
			printf_xy(0,35,"Press [ESC] to quit");
			printf_xy(0,45,"Press [F1] to select/deselect/move a card");
			printf_xy(0,55,"Press [F5] to draw the next card from the");
			printf_xy(10,62,"draw stack");
			printf_xy(0,75,"Press [HOME] to start a new game");
			printf_xy(0,85,"Press [MODE] for options menu");
			FontSetSys(F_6x8);
			ngetchx();
			goto done;
		}
		if(key==266)
		{
optnsmenu:
			ClrScr();
			printf_xy(50,0,"Options");
			FontSetSys(F_4x6);
			t=19;
			printf_xy(0,86,"Press [ENTER] to save/exit");
			printf_xy(0,93,"Press F1 to toggle On/Off");
			printf_xy(0,20,"Auto-move cards to ace stack............");
			printf_xy(0,30,"Auto-flip cards in playing area..........");
opsmenu:
			box(140,20,160,100,0);
			printf_xy(140,20,"On");
			if(options[0]!=1)
				printf_xy(144,20,"ff");
			printf_xy(140,30,"On");
			if(options[1]!=1)
				printf_xy(144,30,"ff");
			box(139,t,153,t+6,-1);
			key=ngetchx();
			if(key==337 || key==340)		//Up and Down, respectively
			{
				box(139,t,153,t+6,-1);
				t=t+(sign(key-338)*10);
				if(t<19)
					t=29;
				if(t>29)
					t=19;
				goto opsmenu;
			}
			if(key==268)
			{
				box(139,t,153,t+6,-1);
				if(t==19)
					options[0]=-options[0];
				if(t==29)
					options[1]=-options[1];
				goto opsmenu;
			}
			if(key==13)
			{
				FontSetSys(F_6x8);
				if(cont==0)
					goto done;
				goto top;
			}
		}
	}
	if(cont==1)
		goto top;
	reset=1;
	FontSetSys(F_6x8);
	
/*The following code draws the playing area*/
	
	ClrScr();
	col=0;
	row=0;
	t=1;
	z=1;
	for(x=1;x<104;x=x+17)												//Draw cards for playing array
	{
		z=z+2;
		for(y=1;y<z;y=y+2)
		{
			drwcrd(0,0,y,x);
			if(y!=z-2)
				DrawLine(x+1,y+21,x+14,y+21,A_REVERSE);
		}
		box(x+1,1,x+14,z-2,2);
	}
	for(x=1;x<104;x=x+17)
	{
		drwcrd(maincrd[row][col],mainsut[row][col],t,x);
		col++;
		row++;
		t=t+2;
	}
	z=3;
	for(y=122;y<142;y=y+19)											//Draw cards for draw stacks and ace stacks
	{
		for(x=73;x>26;x=x-23)
		{
			if(x==27)
				x=x-26;
			drwcrd(0,0,x,y);
			if(x>27)
			{
				drwcrd(0,z,x,y);
				z=z-2;
			}
		}
		z=4;
	}
	printf_xy(124,27,"Card:");
	col=0;
	t=1;
	c=1;
	select=0;
	row=0;
	outln(1);
	box(142,2,155,21,2);
	
/*The following code controlls gameplay*/

top:
	FontSetSys(F_6x8);
	if(cont==1)
	{
		cont=0;
		ClrScr();
		LCD_restore(LCD_BUFFER);
		loccard(col);
		outln(1);
	}
	if(options[0]==1)
	{
		space[0]=row;
		space[1]=col;
		space[2]=t;
		space[3]=c;
		outln(0);
		min=20;
		for(x=0;x<4;x++)
		{
			if(mainace[x]<min)
				min=mainace[x];
		}
		for(x=0;x<7;x++)
		{
			loccard(x);
			if(maincrd[row][x]==(mainace[mainsut[row][x]-1]+1) && maincrd[row][x]<(min+3) && mainsut[row][x]>0)
			{
				select=1;
				selectd[0]=maincrd[row][x];
				selectd[1]=mainsut[row][x];
				selectd[2]=row;
				selectd[3]=x;
				loccard(mainsut[row][x]+10);
				goto moveary;
			}
		}
		if(drawcrd[draw]==(mainace[drawsut[draw]-1]+1) && drawcrd[draw]<(min+3))
		{
			select=1;
			selectd[0]=drawcrd[draw];
			selectd[1]=drawsut[draw];
			selectd[2]=30;
			selectd[3]=10;
			loccard(drawsut[draw]+10);
			goto movedrw;
		}
		row=space[0];
		col=space[1];
		t=space[2];
		c=space[3];
		space[0]=-1;
		space[1]=-1;
		space[2]=-1;
		space[3]=-1;
		outln(1);
	}

	box(128,39,164,49,0);
	x=0;
	y=0;
	if(col<7)
	{
		x=maincrd[row][col];
		y=mainsut[row][col];
	}
	if(col==10)
	{
		if(draw!=0)
		{
			x=drawcrd[draw];
			y=drawsut[draw];
		}
	}
	if(col>10)
	{
		x=mainace[col-11];
		y=col-10;
	}
	if(x==0 || (col<7 && mainsut[row][col]<0))
		goto contn;
	if(x<11)
		printf_xy(128,40,"%d",x);
	if(x==11)
		printf_xy(128,40,"J");
	if(x==12)
		printf_xy(128,40,"Q");
	if(x==13)
		printf_xy(128,40,"K");
	if(x==1)
		printf_xy(128,40,"A");
	if(y==1)
		drwclb(39,142);
	if(y==2)
		drwdmnd(39,142);
	if(y==3)
		drwspd(39,142);
	if(y==4)
		drwhrt(39,142);
contn:
	kng=0;
	z=0;
	for(x=0;x<4;x++)
		z=z+mainace[x];
	if(z==52)
		goto gamedone;
	key=ngetchx();
	if(key==264)												//ESC key
	{
		FontSetSys(F_4x6);
		printf_xy(0,92,"Press [ENTER] to quit");
		FontSetSys(F_6x8);
		if(ngetchx()==13)
			goto gamedone;
		box(0,92,96,98,0);
		goto top;
	}
	
	if(key==266)									//MODE key (options)
	{
		FontSetSys(F_4x6);
		printf_xy(0,92,"Press [ENTER] for options");
		FontSetSys(F_6x8);
		if(ngetchx()==13)
		{
			cont=1;
			reset=0;
			outln(0);
			box(0,92,96,98,0);
			LCD_save(LCD_BUFFER);
			goto optnsmenu;
		}
		box(0,92,96,98,0);
	}
	
	if(key==265)												//APPS key
	{
		LCD_save(LCD_BUFFER);
		ClrScr();
		FontSetSys(F_4x6);
		printf_xy(0,0,"This guide will tell you what the keys do");
		printf_xy(0,10,"Use the arrow keys to move the cursor");
		printf_xy(10,17,"You can also move up or down a stack");
		printf_xy(10,24,"and to ace/draw stacks");
		printf_xy(0,35,"Press [ESC] to quit");
		printf_xy(0,45,"Press [F1] to select/deselect/move a card");
		printf_xy(0,55,"Press [F5] to draw the next card from the");
		printf_xy(10,62,"draw stack");
		printf_xy(0,75,"Press [HOME] to start a new game");
		printf_xy(0,85,"Press [MODE] for options menu");
		FontSetSys(F_6x8);
		ngetchx();
		ClrScr();
		LCD_restore(LCD_BUFFER);
	}
	
	if(key==277)												//Home key
	{
		FontSetSys(F_4x6);
		printf_xy(0,92,"Press [ENTER] to restart");
		FontSetSys(F_6x8);
		reset=1;
		if(ngetchx()==13)
			goto reset;
		reset=0;
		box(0,92,96,98,0);
		goto top;
	}
	
	if(key==268)												//F1 Key (Select/move card)
	{
		if(select==1)
		{
			if(col==selectd[3])							//Card selected==current card (cancel selection)
			{
				for(x=0;x<4;x++)
					selectd[x]=0;
				select=0;
				b=19;
				if(col<7 && mainsut[row+1][col]>0)
					b=4;
				box(c+2,t+2,c+13,t+b,-1);
				goto top;
			}
			if(col<7)		//Card is being moved to playing array
			{
				kng=0;
				if(selectd[0]==13 && mainsut[row][col]==0)
				{
					kng=1;
					goto king;
				}
				if(selectd[0]==13 && mainsut[row][col]<0)
					goto king;
				if(mainsut[row+1][col]>0 || maincrd[row][col]!=selectd[0]+1 || even(mainsut[row][col])==even(selectd[1]) || (mainsut[row][col]==0 && selectd[0]!=13))
					goto top;
king:
				outln(0);
				t=t+5-(5*kng);
				if(selectd[0]==13 && kng==0)
					t=t-3;
				box(c,t,c+15,99,0);
				drwcrd(selectd[0],selectd[1],t,c);
				maincrd[row+1-kng][col]=selectd[0];
				mainsut[row+1-kng][col]=selectd[1];
				if(selectd[3]<7)		//Card is being moved to playing array from playing array
				{
					e=0;
					while(mainsut[selectd[2]+1+e][selectd[3]]!=0)
					{
						e++;
						t=t+5;
						box(c,t,c+15,99,0);
						drwcrd(maincrd[selectd[2]+e][selectd[3]],mainsut[selectd[2]+e][selectd[3]],t,c);
						maincrd[row+1+e-kng][col]=maincrd[selectd[2]+e][selectd[3]];
						mainsut[row+1+e-kng][col]=mainsut[selectd[2]+e][selectd[3]];
						maincrd[selectd[2]+e][selectd[3]]=0;
						mainsut[selectd[2]+e][selectd[3]]=0;
					}
					maincrd[selectd[2]][selectd[3]]=0;
					mainsut[selectd[2]][selectd[3]]=0;	
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]<0 && options[1]==1)
						mainsut[selectd[2]-1][selectd[3]]=abs(mainsut[selectd[2]-1][selectd[3]]);
					loccard(selectd[3]);
					box(c,t,c+15,99,0);
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]<0)
					{
						drwcrd(0,0,t,c);
						box(c+1,t+1,c+14,t+20,2);
					}
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]>0)
						drwcrd(maincrd[selectd[2]-1][selectd[3]],mainsut[selectd[2]-1][selectd[3]],t,c);
					if(mainsut[0][selectd[3]]==0)
						drwcrd(0,0,t,c);
				}
				if(selectd[3]==10)		//Card is being moved to playing array from draw stack
				{
					drawnxt(1);
				}
				if(selectd[3]>10)			//Card is being moved to playing array from ace stack
				{
					mainace[selectd[3]-11]--;
					loccard(selectd[3]);
					box(c,t,c+15,t+21,0);
					drwcrd(mainace[selectd[3]-11],selectd[1],t,c);
				}
				select=0;
				loccard(col);
				outln(1);
				goto top;
			}
			if(col==10)	//Card is being moved to draw stack (dumbass)
				goto top;
			if(col>10)	//Card is being moved to ace stack
			{
				if(selectd[1]!=col-10 || mainace[col-11]+1!=selectd[0])
					goto top;
				if(selectd[3]<7)		//Card is being moved to ace stack from playing array
				{
					if(mainsut[selectd[2]+1][selectd[3]]>0)
						goto top;
moveary:
					box(c,t,c+15,t+21,0);
					drwcrd(selectd[0],selectd[1],t,c);
					maincrd[selectd[2]][selectd[3]]=0;
					mainsut[selectd[2]][selectd[3]]=0;
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]<0 && options[1]==1)
						mainsut[selectd[2]-1][selectd[3]]=abs(mainsut[selectd[2]-1][selectd[3]]);
					mainace[selectd[1]-1]++;
					loccard(selectd[3]);
					box(c,t,c+15,99,0);
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]<0 && options[1]!=1)
					{
						drwcrd(0,0,t,c);
						box(c+1,t+1,c+14,t+20,2);
					}
					if(selectd[2]!=0 && mainsut[selectd[2]-1][selectd[3]]>0)
						drwcrd(maincrd[selectd[2]-1][selectd[3]],mainsut[selectd[2]-1][selectd[3]],t,c);
					else
					{
						if(selectd[2]==0)
							drwcrd(0,0,t,c);
					}
					loccard(col);
					outln(1);
					select=0;
					goto top;
				}
				if(selectd[3]==10)	//Card is being moved to ace stack from draw stack
				{
movedrw:
					box(c,t,c+15,t+21,0);
					drwcrd(selectd[0],selectd[1],t,c);
					mainace[selectd[1]-1]++;
					t=1;
					c=122;
					drawnxt(1);
					loccard(col);
					outln(1);
					select=0;
					goto top;
				}
			}
		}
//Select==0
		b=19;
		if(col<7)		//Card being selected is in playing array
		{
			if(mainsut[row][col]==0)
				goto top;
			if(mainsut[row][col]<0)
			{
				mainsut[row][col]=abs(mainsut[row][col]);
				box(c,t,c+15,t+21,0);
				drwcrd(maincrd[row][col],mainsut[row][col],t,c);
				outln(1);
				goto top;
			}
			if(mainsut[row+1][col]>0)
				b=4;
			selectd[0]=maincrd[row][col];
			selectd[1]=mainsut[row][col];
			selectd[2]=row;
		}
		if(col==10)	//Card being selected is on draw stack
		{
			if(draw==0)
				goto top;
			selectd[0]=drawcrd[draw];
			selectd[1]=drawsut[draw];
			selectd[2]=30;
		}
		if(col>10)	//Card being selected is on an ace stack
		{
			if (mainace[col-11]==0)
				goto top;
			selectd[0]=mainace[col-11];
			selectd[1]=col-10;
			selectd[2]=30;
		}
		box(c+2,t+2,c+13,t+b,-1);
		selectd[3]=col;
		select=1;
		goto top;
	}
	
	if(key==272)												//F5 Key (Draw next card)
	{
		if(select==1 && selectd[3]==10)
			goto top;
		drawnxt(0);
		outln(1);
		goto top;
	}
	
	if((key==4433 || key==16721) && col<7)					//Alt-Up
	{
		outln(0);
		for(x=0;x<20;x++)
		{
			if(mainsut[x][col]>0)
				break;
		}
		row=x;
		t=x*2+1;
		outln(1);
		goto top;
	}
	
	if((key==4436 || key==16724) && col<7)					//Alt-Down
	{
		outln(0);
		loccard(col);
		outln(1);
		goto top;
	}
	
	if(key==337 || key==340)						//Up and Down arrows, respectively
	{
		if(col>6)
		{
			outln(0);
			if(key==337)
			{
				if(col==11 ||col==12)
				{
					col=10;
					t=1;
					c=122;
					outln(1);
					goto top;
				}
				if(col==13 || col==14)
				{
					col=col-2;
					t=t-23;
					outln(1);
					goto top;
				}
				if(col==10)
				{
					col=13;
					t=73;
					outln(1);
					goto top;
				}
			}
			if(key==340)
			{
				if(col==10)
				{
					col++;
					t=t+49;
					outln(1);
					goto top;
				}
				if(col==11 || col==12)
				{
					col=col+2;
					t=t+23;
					outln(1);
					goto top;
				}
				if(col==13 || col==14)
				{
					col=10;
					t=1;
					c=122;
					outln(1);
					goto top;
				}
			}
		}
		if(key==337 && row<1)
			goto top;
		if(key==340 && mainsut[row+1][col]==0)
			goto top;
		d=sign(key-338);
		if(mainsut[row+d][col]<1)
			goto top;
		outln(0);
		t=t+5*d;
		row=row+d;
		outln(1);
		goto top;
	}
	
	if(key==338 || key==344)						//Left and Right arrows, respectively
	{
		outln(0);
		if(key==338 && (col<1 || col>6))
		{
			if(col==12 || col==14)
			{
				col--;
				c=c-19;
				outln(1);
				goto top;
			}
			if(col==13 || col==11 || col==10)
			{
				col=6;
				loccard(col);
				outln(1);
				goto top;
			}
			if(col==0)
			{
				col=14;
				row=0;
				c=141;
				t=73;
				outln(1);
				goto top;
			}
		}
		if(key==344 && col>5)
		{
			outln(0);
			if(col==10 || col==12 || col==14)
			{
				col=0;
				loccard(col);
				outln(1);
				goto top;
			}
			if(col==6)
			{
				col=10;
				t=1;
				c=122;
				outln(1);
				goto top;
			}
			if(col==11 || col==13)
			{
				col++;
				c=c+19;
				outln(1);
				goto top;
			}
		}
		col=col+sign(key-340);
		loccard(col);
		outln(1);
		goto top;
	}
	goto top;
gamedone:
	if(z==52)
	{
		printf_xy(12,30,"Enter = New Game");
		printf_xy(24,40,"Esc = Quit");
		key=0;
		while(key!=264)
		{
			key=ngetchx();
			if(key==13)
			{
				reset=1;
				goto reset;
			}
		}
	}
	select=0;
	for(x=0;x<4;x++)
	{
		selectd[x]=0;
		mainace[x]=0;
	}
	GrayOff();
	ClrScr();
}

int sumit(int lst[13])
{
	int x=0,y=0;
	for(;x<13;x++)
		y=y+lst[x];
	return y;
}

void drwcrd(int card,int suit,int t,int c)
{
	DrawLine(c,t+1,c,t+20,A_NORMAL);
	DrawLine(c+1,t,c+14,t,A_NORMAL);
	DrawLine(c+15,t+1,c+15,t+20,A_NORMAL);
	DrawLine(c+1,t+21,c+14,t+21,A_NORMAL);
	DrawPix(c,t,A_REVERSE);
	DrawPix(c+15,t,A_REVERSE);
	if(card<11 && card>0)
		printf_xy(c+2,t+2,"%d",card);
	if(card==1)
		printf_xy(c+2,t+2,"A");
	if(card==11)
		printf_xy(c+2,t+2,"J");
	if(card==12)
		printf_xy(c+2,t+2,"Q");
	if(card==13)
		printf_xy(c+2,t+2,"K");
	if(suit==1)
		drwclb(t+10,c+5);
	if(suit==2)
		drwdmnd(t+10,c+5);
	if(suit==3)
		drwspd(t+10,c+5);
	if(suit==4)
		drwhrt(t+10,c+5);
}

void outln(int x)
{
	if(x==1)
	{
		DrawLine(c+1,t+1,c+14,t+1,A_NORMAL);
		if(mainsut[row+1][col]==0  || col>6)
		{
			DrawLine(c+1,t+1,c+1,t+20,A_NORMAL);
			DrawLine(c+14,t+1,c+14,t+20,A_NORMAL);
			DrawLine(c+1,t+20,c+14,t+20,A_NORMAL);
		}
		DrawLine(c+1,t+1,c+1,t+4,A_NORMAL);
		DrawLine(c+14,t+1,c+14,t+4,A_NORMAL);
	}
	if(x==0)
	{
		DrawLine(c+1,t+1,c+14,t+1,A_REVERSE);
		if(mainsut[row+1][col]==0 || col>6)
		{
			DrawLine(c+1,t+1,c+1,t+20,A_REVERSE);
			DrawLine(c+14,t+1,c+14,t+20,A_REVERSE);
			DrawLine(c+1,t+20,c+14,t+20,A_REVERSE);
		}
		DrawLine(c+1,t+1,c+1,t+4,A_REVERSE);
		DrawLine(c+14,t+1,c+14,t+4,A_REVERSE);
		if(mainsut[row][col]<0 && col<7)
			box(c+1,t+1,c+14,t+20,2);
	}
}

void drwclb(int r,int c)							//Thanks to 'SlipsZERO' for bringing this method to my attention (much faster)
{
	unsigned char	clbsprt[]={0x18,0x3C,0x3C,0x18,0x7E,0xFF,0x7E,0x18,0x3C};
	Sprite8(c-1,r,9,clbsprt,LCD_MEM,A_NORMAL);
}

void drwdmnd(int r,int c)
{
	unsigned char	dmndsprt[]={0x20,0x20,0x50,0x50,0x88,0x50,0x50,0x20,0x20};
	Sprite8(c,r,9,dmndsprt,LCD_MEM,A_NORMAL);
}

void drwspd(int r,int c)
{
	unsigned char	spdsprt[]={0x20,0x20,0x70,0x70,0xF8,0xF8,0x20,0x70};
	Sprite8(c,r,8,spdsprt,LCD_MEM,A_NORMAL);
}

void drwhrt(int r,int c)							//Another thanks to 'SlipsZERO' for tweaking the heart design
{
	unsigned char	hrtsprt[]={0x50,0xA8,0x88,0x50,0x50,0x20,0x20};
	Sprite8(c,r+1,7,hrtsprt,LCD_MEM,A_NORMAL);
}

void loccard(int col)
{
	int x=0,y=0,z=0;
	if(col==10)
	{
		t=1;
		c=122;
		row=30;
		return;
	}
	if(col==11)
	{
		t=50;
		c=122;
		row=30;
		return;
	}
	if(col==12)
	{
		t=50;
		c=141;
		row=30;
		return;
	}
	if(col==13)
	{
		t=73;
		c=122;
		row=30;
		return;
	}
	if(col==14)
	{
		t=73;
		c=141;
		row=30;
		return;
	}
	for(;x<20;x++)
	{
		if(mainsut[x][col]>0)
			y++;
		if(mainsut[x][col]<0)
			z++;
	}
	if(y==0 && z==0)
		y=1;
	t=1+2*z+5*(y-1);
	if(y==0 && z!=0)
		t=t+3;
	c=1+17*(col);
	row=y+z-1;
}

void drawnxt(int x)
{
	int y;
	box(142,2,155,21,0);
	box(123,2,136,21,0);
	if(x==1)
	{
		for(y=draw;y<25;y++)
		{
			drawcrd[y]=drawcrd[y+1];
			drawsut[y]=drawsut[y+1];
		}
		draw--;
	}
	if(x==0)
		draw++;
	if(drawcrd[draw]==-1)
		draw=0;
	if(draw>0)
		drwcrd(drawcrd[draw],drawsut[draw],1,122);
	if(drawcrd[draw+1]!=-1)
	{
		box(142,2,155,21,2);
	}
}